mod Ex08

incl Mtex

incl Mtexgr

incl Maux

incl Mterm

incl Mrd

loc rem 
  8. CVICENIE Z PREDMETU TEORIA VYPOCITATELNOSTI PRE PROGRAMATOROV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 10.11.2005
  ******************************************************************************
  PMAIL: comp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/comp
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
  ULOHY: 20%
  MIDTERM: 20%
  FINALTERM: 60%
  ******************************************************************************
  POCET BODOV ZA ULOHY V TOMTO SUBORE: 1
  POCET BODOV ZA PREMIOVE ULOHY V TOMTO SUBORE: 1
  ******************************************************************************
  PRENOS: <cl>/4i/prenos/ex/ex08/<vase meno>/ex08.cl
          kde <cl> je adresar /data/VYUKA/INF/CL na barbie.nw.fmph.uniba.sk
          ************************************************
          *** odovzdat do 8.11.2005 (utorok) do 18:00 ***
          ************************************************
  ******************************************************************************

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parcialne 
  rekurzivnym funkciam. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor \it  maux.cl  \end obsahuju definicie niektorych funkcii a 
         predikatov. 
   \item \para Subor \it  mterm.cl  \end obsahuje aritmetizaciu rekurzivnych 
         termov. 
   \item \para Subor \it  mrd.cl  \end obsahuje aritmetizaciu vypoctoveho 
         modelu. 
   \item \para Subor \it  ex08.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 Q  \end See the module \it  
  Mclsyntax  \end in the file \it  mclsyntax.cl  \end. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Recursive Functions.  \end 

rem 
  \para \bf  Kleene's T-predicate.  \end \it  [Uloha (1 bod)]  \end 

pred/3 T1 
  T1(e,x1,y) <-> Poo

pred/4 T2 
  T2(e,x1,x2,y) <-> Poo

pred/5 T3 
  T3(e,x1,x2,x3,y) <-> Poo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end Let 
  \ft Texm_f0_class_f \end be the smallest class of functions containing 
  \items 
   \item \para the successor function \ft x+1 \end, 
   \item \para the predecessor function \ft x-1 \end, 
  \end
  \para and it is closed under regular recursive definitions (note that this 
  includes explicit definitions). Show that \ft Texm_f0_class_f \end is closed 
  under the operator of regular minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. Recall that the class \ft Texm_f0_class_f \end is primitively 
  recursively closed. 

theory Operator_of_regular_minimalization

fun/2 G 'Tex_f2_g'

rem 
  \para \header* fun F 'Tex_f1_f' \end Suppose \ft G(y,x) \end is in 
  \ft Texm_f0_class_f \end. Suppose that we have 
  \eq* 
    \a x\e y G(y,x) = 1
  \end
  \para Show that the function \ft F(x) \end defined by 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y [ G(y,x) = 1 ]
  \end
  \para is also in \ft Texm_f0_class_f \end. 

fun F 'Tex_f1_f'
  F(x) = Foo

end theory Operator_of_regular_minimalization

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

